package cn.com.infosec.asn1.x509;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERObjectIdentifier;
import cn.com.infosec.asn1.DERSequence;
import java.util.Enumeration;
import java.util.Vector;

public class CertificatePolicies extends ASN1Encodable {
   static final DERObjectIdentifier anyPolicy = new DERObjectIdentifier("2.5.29.32.0");
   Vector policies;

   /** @deprecated */
   public static CertificatePolicies getInstance(ASN1TaggedObject obj, boolean explicit) {
      return getInstance(ASN1Sequence.getInstance(obj, explicit));
   }

   /** @deprecated */
   public static CertificatePolicies getInstance(Object obj) {
      if (obj instanceof CertificatePolicies) {
         return (CertificatePolicies)obj;
      } else if (obj instanceof ASN1Sequence) {
         return new CertificatePolicies((ASN1Sequence)obj);
      } else {
         throw new IllegalArgumentException("unknown object in factory: " + obj.getClass().getName());
      }
   }

   /** @deprecated */
   public CertificatePolicies(ASN1Sequence seq) {
      ASN1Sequence var10000 = seq;
      super();
      Vector seq1;
      seq1 = new Vector.<init>();
      this.policies = seq1;
      Enumeration seq2 = var10000.getObjects();

      while(seq2.hasMoreElements()) {
         ASN1Sequence var2 = ASN1Sequence.getInstance(seq2.nextElement());
         this.policies.addElement(var2.getObjectAt(0));
      }

   }

   /** @deprecated */
   public CertificatePolicies(DERObjectIdentifier p) {
      Vector var2;
      Vector var10000 = var2 = new Vector;
      var2.<init>();
      this.policies = var2;
      var10000.addElement(p);
   }

   /** @deprecated */
   public CertificatePolicies(String p) {
      CertificatePolicies var10000 = this;
      DERObjectIdentifier var2;
      var2 = new DERObjectIdentifier.<init>(p);
      var10000.<init>(var2);
   }

   public void addPolicy(String p) {
      this.policies.addElement(new DERObjectIdentifier(p));
   }

   public String getPolicy(int nr) {
      return this.policies.size() > nr ? ((DERObjectIdentifier)this.policies.elementAt(nr)).getId() : null;
   }

   /** @deprecated */
   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      var1 = new ASN1EncodableVector.<init>();

      for(int var2 = 0; var2 < this.policies.size(); ++var2) {
         var1.add(new DERSequence((DERObjectIdentifier)this.policies.elementAt(var2)));
      }

      return new DERSequence(var1);
   }

   public String toString() {
      String var1 = null;

      for(int var2 = 0; var2 < this.policies.size(); ++var2) {
         if (var1 != null) {
            var1 = var1 + ", ";
         }

         var1 = var1 + ((DERObjectIdentifier)this.policies.elementAt(var2)).getId();
      }

      return "CertificatePolicies: " + var1;
   }
}
